Wt: Wt::WCircleArea Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Wt::WCircleArea Class Reference

A interactive area in a widget, specified by a circle. More...

`#include <Wt/WCircleArea.h>`

Inheritance diagram for Wt::WCircleArea:
[legend]

## Public Member Functions
| WCircleArea ()
| Default constructor.
| WCircleArea (int x, int y, int radius)
| Creates a circular area with given geometry.
void | setCenter (const WPoint &point)
| Sets the center.
void | setCenter (const WPointF &point)
| Sets the center.
void | setCenter (int x, int y)
| Sets the center.
int | centerX () const
| Returns the center X coordinate.
int | centerY () const
| Returns the center Y coordinate.
void | setRadius (int radius)
| Sets the radius.
int | radius () const
| Returns the radius.
Public Member Functions inherited from Wt::WAbstractArea
virtual | ~WAbstractArea ()
| Destructor.
void | setHole (bool hole)
| Specifies that this area specifies a hole for another area.
bool | isHole () const
| Returns whether this area specifies a hole.
void | setLink (const WLink &link)
| Sets a link.
WLink | link () const
| Returns the link.
void | setAlternateText (const WString &text)
| Sets an alternate text.
const WString | alternateText () const
| Returns the alternate text.
void | setToolTip (const WString &text)
| Sets the tooltip.
WString | toolTip () const
| Returns the tooltip text.
void | setStyleClass (const WString &styleClass)
| Defines a style class.
WString | styleClass () const
| Returns the style class.
void | addStyleClass (const WString &styleClass, bool force=false)
| Adds a style class.
void | removeStyleClass (const WString &styleClass, bool force=false)
| Removes a style class.
void | setCursor (Cursor cursor)
| Sets the cursor.
void | setCursor (std::string cursorImage, Cursor fallback=Cursor::Arrow)
| Sets a custom cursor image URL.
Cursor | cursor () const
| Returns the cursor.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when a mouse key was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when a mouse key was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse key was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse key was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual const std::string | id () const
| Returns the (unique) identifier for this object.
virtual void | setObjectName (const std::string &name)
| Sets an object name.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WObject
Protected Member Functions inherited from Wt::WAbstractArea
Protected Member Functions inherited from Wt::WObject
virtual WStatelessSlot * | getStateless (Method method)
| On-demand stateless slot implementation.

## Detailed Description

A interactive area in a widget, specified by a circle.

The area may be added to a WImage or WPaintedWidget to provide interactivity on a circular area of the image. The circle is specified in pixel coordinates.

Usage example:

Wt::WImage *image = addWidget(std::make_unique<Wt::WImage>("images/events.png"));
Wt::WCircleArea *area = image->addArea(std::make_unique<Wt::WCircleArea>(20, 30, 15));
area->clicked().connect(this, &MyWidget::areaClicked);
Wt::WAbstractArea::clicked
EventSignal< WMouseEvent > & clicked()
Event signal emitted when a mouse key was clicked on this widget.
Wt::WCircleArea
A interactive area in a widget, specified by a circle.
Definition WCircleArea.h:38
Wt::WImage
A widget that displays an image.
Definition WImage.h:54
Wt::WImage::addArea
void addArea(std::unique_ptr< WAbstractArea > area)
Adds an interactive area.

See also
  WImage::addArea(), WPaintedWidget::addArea()
  WRectArea, WPolygonArea

## Constructor & Destructor Documentation

## ◆ WCircleArea() [1/2]

Wt::WCircleArea::WCircleArea | ( |  | ) |

Default constructor.

Specifies a circular area with center (0, 0) and radius 0.

## ◆ WCircleArea() [2/2]

Wt::WCircleArea::WCircleArea | ( | int | x,
|  | int | y,
|  | int | radius )

Creates a circular area with given geometry.

The arguments are in pixel units.